uses objectclass;

define :class Priority_Queue;
    slot buffer;
    slot index;
enddefine;

define make_Priority_Queue();
   return(consPriority_Queue(initv(16), 1));
enddefine;

define :method empty(pq : Priority_Queue);
    return(index(pq) = 1);
enddefine;

define :method insert(pq : Priority_Queue, item);
    if index(pq) = length(buffer(pq)) + 1 then
        resize(pq);
    endif;
    item ->buffer(pq)(index(pq));
    index(pq) + 1 -> index(pq);
enddefine;

define :method remove(pq : Priority_Queue);
    if index(pq) = 1 then
        return([]);
    endif;
    lvars buf = buffer(pq);
    lvars max_index = 1;
    lvars i;

    for i from 2 to index(pq) - 1 do
        if compare(buf(i), buf(max_index)) > 0 then
            i -> max_index;
        endif;
    endfor;
    lvars result = buf(max_index);

    ;;; move the last item into the empty slot
    index(pq) - 1 -> index(pq);
    buf(index(pq)) -> buf(max_index);
    return(result);
enddefine;

define :mixin Integer;
enddefine;

define :extant integer is Integer;
enddefine;

define :extant biginteger is Integer;
enddefine;

define :method compare(x : Integer, y : Integer);
    if x > y then
        return(1);
    elseif x = y then
        return(0);
    else
        return(-1);
    endif;
enddefine;

lvars pq = make_Priority_Queue ();
insert(pq, 17);
insert(pq, 12);
insert(pq, 44);

while not(empty(pq)) do
   lvars item = remove(pq);
   printf (item, '%p\n');
endwhile;

define :class Golfer;
    slot name;
    slot score;
enddefine;

define :method compare(x : Golfer, y : Golfer);
    lvars a = score(x);
    lvars b = score(y);

    ;;; for golfers, low is good!
    if a < b then
        return(1);
    elseif a > b then
        return(-1);
    else
        return(0);
    endif;
enddefine;

lvars tiger = consGolfer ('Tiger Woods', 61);
lvars phil = consGolfer ('Phil Mickelson', 72);
lvars hal = consGolfer ('Hal Sutton', 69);

insert(pq, tiger);
insert(pq, phil);
insert(pq, hal);

while not(empty(pq)) do
    lvars golfer = remove(pq);
    printf(golfer, '%p\n');
endwhile;

